# -----------------------------------------------------------------------------
# $Id: FunctionalVariable.pm,v 1.1 2003/08/12 01:45:35 admin Exp $
# -----------------------------------------------------------------------------
# FunctionalVariableϡͿ줿Ǥդδؿե󥹤Ƥ֤褦
# ѿ˽ؿtieޤTie::ScalarȤΰ㤤ϡؿ
# ѥǤϤʤ˷Ǥ
# -----------------------------------------------------------------------------
# Ȥ:
#
# 顼ѿ˳Ƥ:
# my $foo;
# FunctionalVariable::tie(
#     \$foo,
#     FETCH => sub {
#         # FETCHϾάǽ
#         return 500;
#     },
#     STORE => sub {
#         # STOREάǽ
#         print shift;
#     },
# );
# print "$foo\n"; # "500\n"
# $foo = 10;      # "10"
# -----------------------------------------------------------------------------
# ư:
#
# FunctionalVariable::tie¹ԤȡѿˤFunctionalVariable
# ֥Ȥtie롣FunctionalVariable::FETCH¾ϡtie¹Ի
# ꤵ줿ؿ˼ºݤνѾ롣
# -----------------------------------------------------------------------------
package FunctionalVariable;
use strict;
use warnings;
use Carp;

sub tie {
    # $variable: tieѿؤλ
    # @functions: ؿ
    my ($variable, @functions) = @_;

    # @functionsθ
    my $functions = eval {
	my $funcs = {@functions};
	while (my ($key, $value) = each %$funcs) {
	    if (ref($value) ne 'CODE') {
		die "FunctionalVariable->tie, Arg[1]{$key} is not a function ref.\n";
	    }
	}
	$funcs;
    }; if ($@) {
	croak $@;
    }

    my $this = {
	variable => $variable,
	type => ref($variable),
	functions => $functions,
    };

    if ($this->{type} eq 'SCALAR') {
	tie $$variable, 'FunctionalVariable', $this;
    }
    elsif ($this->{type} eq '') {
	croak "FunctionalVariable->tie, Arg[0] was not a ref.\n";
    }
    else {
	croak "FunctionalVariable->tie, Arg[0] was bad ref: $this->{type}\n";
    }
}

sub TIESCALAR {
    my ($class, $this) = @_;
    bless $this => $class;
}

sub FETCH {
    my ($this) = @_;
    my $f = $this->{functions}{'FETCH'};
    if (defined $f) {
	$f->();
    }
    else {
	# FETCHƤʤΤʤ顢undefǤ֤¾̵
	undef;
    }
}

sub STORE {
    my ($this, $value) = @_;
    my $f = $this->{functions}{'STORE'};
    if (defined $f) {
	$f->($value);
    }
    # STOREƤʤΤʤ顢⤷ʤ
}

1;
